#ifndef _HMC5883_H
#define _HMC5883_H

#define CONF_REG_A 0x00
#define CONF_REG_B 0x01
#define MOD_REG    0x02
#define STATUS_REG 0x09
#define OUTPUT_X   0x03

/* Output rate */
#define OR_0075 0x00<<2
#define OR_0150 0x01<<2
#define OR_0300 0x02<<2
#define OR_0750 0x03<<2
#define OR_1500 0x04<<2
#define OR_3000 0x05<<2
#define OR_7500 0x06<<2
#define OR_RES  0x07<<2

/* Measurement mode */
#define MM_NORMAL 0x00
#define MM_POS    0x01
#define MM_NEG    0x02
#define MM_RES    0x03

/* Gain */
#define GN_1370 0x00<<5
#define GN_1090 0x01<<5
#define GN_820  0x02<<5
#define GN_660  0x03<<5
#define GN_440  0x04<<5
#define GN_390  0x05<<5
#define GN_330  0x06<<5
#define GN_230  0x07<<5

/* Operation mode */
#define HIGH_SPEED      0x80
#define MD_CONTINOUS    0x00
#define MD_SINGLE       0x01
#define MD_IDLE         0x03

struct _registers_t{
    char name[50];
    unsigned char address;
    unsigned char default_value;
    unsigned char current_value;
};

extern struct _registers_t regs[13];

extern int debug;
extern float declination;
extern float resolution;

/* Functions */
void list_output_rate(void);
void list_measurement_mode(void);
void list_gain(void);
void list_operating_mode(void);

int InitializeModule(int *fd, char *i2c, unsigned char address);
float GetHeading(int *fd);


#endif
